package com.fp.persistence.pgeneral.menu;

import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.Column;
import javax.persistence.EntityManager;
import java.io.Serializable;
import javax.persistence.Table;
import com.fp.dto.hb.HibernateBean;
import java.lang.reflect.Field;
import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TGENEMENUSUBLEVELTRAN*/
@Entity(name="TgeneMenuSubLevelTran")
@Table(name="TGENEMENUSUBLEVELTRAN")
public class TgeneMenuSubLevelTran extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TgeneMenuSubLevelTran
*/
@EmbeddedId
private TgeneMenuSubLevelTranKey pk;
@Column(name="PRESENTATIONORDER", nullable=true)

/**
* Orden de presentacion
*/
private Integer presentationorder;

/**Contructor por defecto*/
public TgeneMenuSubLevelTran(){
}
/**Contructor de TgeneMenuSubLevelTran
@param pPk Clave Primaria del entity
*/
public TgeneMenuSubLevelTran(TgeneMenuSubLevelTranKey pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TgeneMenuSubLevelTran
*/
public static TgeneMenuSubLevelTran find(EntityManager pEntityManager,TgeneMenuSubLevelTranKey pKey) throws Exception{
    TgeneMenuSubLevelTran obj = pEntityManager.find(TgeneMenuSubLevelTran.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TgeneMenuSubLevelTran
@return El objeto que referencia a la Clave primaria de TgeneMenuSubLevelTran
*/
public TgeneMenuSubLevelTranKey getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TgeneMenuSubLevelTran
@param pPk El objeto que referencia a la nueva Clave primaria de TgeneMenuSubLevelTran
*/
public void setPk(TgeneMenuSubLevelTranKey pPk){
  pk=pPk;
}
/**Obtiene el valor de presentationorder
@return valor de presentationorder*/
public Integer getPresentationorder(){
  return presentationorder;
}
/**Fija el valor de presentationorder
@param pPresentationorder nuevo Valor de presentationorder*/
public void setPresentationorder(Integer pPresentationorder){
  presentationorder=pPresentationorder;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TgeneMenuSubLevelTran))return false;
    TgeneMenuSubLevelTran that = (TgeneMenuSubLevelTran) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementación del metodo hashCode de la la entidad TgeneMenuSubLevelTran
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementación de la creación de un bean en blanco TgeneMenuSubLevelTran
*/
public Object createInstance(){
 TgeneMenuSubLevelTran instance=new TgeneMenuSubLevelTran();	
 instance.setPk(new TgeneMenuSubLevelTranKey());
 return instance;
}
/**Clona la entidad TgeneMenuSubLevelTran
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TgeneMenuSubLevelTran p=(TgeneMenuSubLevelTran)this.clone();
  p.setPk((TgeneMenuSubLevelTranKey)this.pk.cloneMe());
  return p;
}
}
